diff --git a/game/client/src/main/java/net/minecraft/client/option/enums/TextOutlineQuality.java b/game/client/src/main/java/net/minecraft/client/option/enums/TextOutlineQuality.java
new file mode 100644
index 000000000..c4273e351
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/option/enums/TextOutlineQuality.java
@@ -0,0 +1,6 @@
+package net.minecraft.client.option.enums;
+
+public enum TextOutlineQuality {
+    FAST,
+    FANCY;
+}
diff --git a/game/client/src/main/java/net/minecraft/client/option/enums/TextureAnimation.java b/game/client/src/main/java/net/minecraft/client/option/enums/TextureAnimation.java
new file mode 100644
index 000000000..b40e38f34
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/option/enums/TextureAnimation.java
@@ -0,0 +1,7 @@
+package net.minecraft.client.option.enums;
+
+public enum TextureAnimation {
+    OFF,
+    PROCEDURAL,
+    CUSTOM;
+}
diff --git a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java
index 9727b497e..bd72be525 100644
--- a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java
+++ b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java
@@ -123,7 +123,7 @@ public abstract class PlayerController {
                 this.setMineBlock(tilePos);
             }
 
-            Objects.requireNonNull(this.mc.particleEngine).crack(tilePos.x(), tilePos.y(), tilePos.z(), side);
+            Objects.requireNonNull(this.mc.particleEngine).crack(tilePos, side);
             this.playDigSound(mineBlock, tilePos);
 
             this.destroyProgress += mineStrength;
diff --git a/game/client/src/main/java/net/minecraft/client/render/EntityRendererDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/EntityRendererDispatcher.java
index 0b47c55be..dcf353d2f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/EntityRendererDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/EntityRendererDispatcher.java
@@ -23,7 +23,6 @@ import net.minecraft.core.item.Items;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.entity.Entity;
@@ -45,7 +44,6 @@ public final class EntityRendererDispatcher {
     public final @NotNull TextureManager textureManager;
     public final @NotNull TexturePackList packList;
     public final @NotNull FontRenderer font;
-    public final @NotNull GameSettings settings;
     public float viewLerpYaw = 0;
     public float viewLerpPitch = 0;
     public double viewLerpPosX = 0;
@@ -57,7 +55,6 @@ public final class EntityRendererDispatcher {
         this.textureManager = mc.textureManager;
         this.packList = mc.texturePackList;
         this.font = mc.font;
-        this.settings = mc.gameSettings;
         reload();
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/FogManager.java b/game/client/src/main/java/net/minecraft/client/render/FogManager.java
index a3ab99b23..717428414 100644
--- a/game/client/src/main/java/net/minecraft/client/render/FogManager.java
+++ b/game/client/src/main/java/net/minecraft/client/render/FogManager.java
@@ -2,6 +2,7 @@ package net.minecraft.client.render;
 
 import static net.minecraft.client.render.uniform.UniformBlock.N;
 
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.world.WorldClient;
 import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.world.pos.TilePos;
@@ -43,7 +44,7 @@ public class FogManager {
 
         float brightnessAtCamera = this.mc.currentWorld.getLightBrightness(this.mc.activeCamera.getTilePos());
         if (this.mc.fullbright) brightnessAtCamera = 1.0f;
-        float renderDistanceModifier = (((this.mc.gameSettings.renderDistance.highest - this.mc.gameSettings.renderDistance.value) * fogModifier) / (float) this.mc.gameSettings.renderDistance.highest);
+        float renderDistanceModifier = (((GameSettings.RENDER_DISTANCE.highest - GameSettings.RENDER_DISTANCE.value) * fogModifier) / (float) GameSettings.RENDER_DISTANCE.highest);
 
         float newBrightness = brightnessAtCamera * (1.0F - renderDistanceModifier) + renderDistanceModifier;
 
@@ -62,7 +63,7 @@ public class FogManager {
             cameraState = 0;
         }
 
-        if (!this.mc.gameSettings.fog.value && fogMode != FOG_MODE_SKY && cameraState == 0) {
+        if (!GameSettings.FOG.value && fogMode != FOG_MODE_SKY && cameraState == 0) {
             return dest.disable();
         }
 
@@ -79,7 +80,7 @@ public class FogManager {
             }
             default: {
                 float fogDistance = farPlaneDistance;
-                float maxFogDistance = this.mc.gameSettings.renderDistance.highest * 16;
+                float maxFogDistance = GameSettings.RENDER_DISTANCE.highest * 16;
 
                 float fogModifier = this.mc.currentWorld.getCurrentWeather() != null ? this.mc.currentWorld.getCurrentWeather().getFogDistanceMultiplier() : 1.0f;
                 fogModifier = (1.0f - ((1.0f - fogModifier) * this.mc.currentWorld.weatherManager.getWeatherIntensity() * this.mc.currentWorld.weatherManager.getWeatherPower()));
@@ -109,7 +110,7 @@ public class FogManager {
     public void updateFogColor(float partialTick) {
         WorldClient world = this.mc.currentWorld;
 
-        float renderDistanceScale = 1.0F / (float) ((this.mc.gameSettings.renderDistance.highest + 8) - this.mc.gameSettings.renderDistance.value);
+        float renderDistanceScale = 1.0F / (float) ((GameSettings.RENDER_DISTANCE.highest + 8) - GameSettings.RENDER_DISTANCE.value);
         renderDistanceScale = 1.0F - (float) Math.pow(renderDistanceScale, 0.25D);
 
         Vector3fc skyColor = world.getSkyColor(this.mc.activeCamera, partialTick);
@@ -136,7 +137,7 @@ public class FogManager {
             this.fogRed = 0.02F;
             this.fogGreen = 0.02F;
             this.fogBlue = 0.2F;
-            if (this.mc.gameSettings.biomeWater.value) {
+            if (GameSettings.BIOME_WATER.value) {
                 TilePos cameraTile = this.mc.activeCamera.getTilePos();
                 double temp = world.getBlockTemperature(cameraTile);
                 double humid = world.getBlockHumidity(cameraTile);
@@ -196,7 +197,7 @@ public class FogManager {
         public @NotNull FogState disable() {
             this.fogMode = FogState.Mode.EXP;
             this.fogDensity = 0.0F;
-            float maxFogDistance = Minecraft.getMinecraft().gameSettings.renderDistance.highest * 16;
+            float maxFogDistance = GameSettings.RENDER_DISTANCE.highest * 16;
             this.fogStart = maxFogDistance * 0.25f;
             this.fogEnd = maxFogDistance;
             return this;
diff --git a/game/client/src/main/java/net/minecraft/client/render/LightmapHelper.java b/game/client/src/main/java/net/minecraft/client/render/LightmapHelper.java
index dc821788a..7689e475a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/LightmapHelper.java
+++ b/game/client/src/main/java/net/minecraft/client/render/LightmapHelper.java
@@ -8,6 +8,7 @@ import com.mojang.logging.LogUtils;
 import net.minecraft.client.GLAllocation;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.ScreenPhotoMode;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.option.enums.LightmapStyle;
 import net.minecraft.client.util.helper.Textures;
 import net.minecraft.client.util.helper.Buffer;
@@ -42,7 +43,7 @@ public class LightmapHelper {
 	
 	public void setup() {
 		World world = this.mc.currentWorld;
-		if(this.mc.gameSettings.customLightmap.value && world != null) {
+		if(GameSettings.CUSTOM_LIGHTMAP.value && world != null) {
 			int dimension = world.dimension.id;
 			
 			String path = "/assets/minecraft/textures/environment/lightmap" + dimension + ".png";
@@ -91,10 +92,10 @@ public class LightmapHelper {
 		if(this.mc.fullbright) {
             Arrays.fill(this.lightmapData, 0xFFFFFFFF);
 		} else {
-			if(this.mc.gameSettings.customLightmap.value && this.customLightmap != null) {
+			if(GameSettings.CUSTOM_LIGHTMAP.value && this.customLightmap != null) {
 				generateCustomLightmap(world);
 			}else {
-				LightmapStyle lightmapStyle = this.mc.gameSettings.lightmapStyle.value;
+				LightmapStyle lightmapStyle = GameSettings.LIGHTMAP_STYLE.value;
 				
 				if(lightmapStyle == LightmapStyle.COLORIZED) {
 					generateColorizedLightmap(world, partialTicks);
@@ -126,7 +127,7 @@ public class LightmapHelper {
 	}
 
 	public void generateGrayLightmap(World world, float partialTicks) {
-		boolean smooth = this.mc.gameSettings.ambientOcclusion.value;
+		boolean smooth = GameSettings.AMBIENT_OCCLUSION.value;
 		
 		for(int i = 0; i < 256; i++) {
 			final int skyLightLevel = i / 16;
@@ -148,7 +149,7 @@ public class LightmapHelper {
 				brightness = world.worldType.getBrightnessRamp()[light];
 			}
 			
-			brightness = applyGamma(brightness, this.mc.gameSettings.brightness.value - 0.5f);
+			brightness = applyGamma(brightness, GameSettings.BRIGHTNESS.value - 0.5f);
 			brightness = MathHelper.clamp(brightness, 0.0f, 1.0f);
 
 			int brightnessI = (int) (brightness * 255);
@@ -161,7 +162,7 @@ public class LightmapHelper {
 	
 	public void generateColorizedLightmap(World world, float partialTicks) {
 		float ambientBrightness = world.getAmbientBrightness(partialTicks);
-		float brightness = this.mc.gameSettings.brightness.value - 0.5f;
+		float brightness = GameSettings.BRIGHTNESS.value - 0.5f;
 
 		for(int i = 0; i < 256; i++) {
 			float skyLight = getBrightnessRemoveMinLight(world, i / 16) * (ambientBrightness * 0.95f + 0.05f);
@@ -205,7 +206,7 @@ public class LightmapHelper {
 	
 	public void generateCustomLightmap(World world) {
 		float ambientBrightness = (world.getAmbientBrightness(1.0f) - 0.2f) / 0.8f;
-		float brightness = this.mc.gameSettings.brightness.value;
+		float brightness = GameSettings.BRIGHTNESS.value;
 		
 		int skylightX = MathHelper.floor_float(ambientBrightness * (this.customLightmap.getWidth() - 2));
 		
diff --git a/game/client/src/main/java/net/minecraft/client/render/LoadingScreenRenderer.java b/game/client/src/main/java/net/minecraft/client/render/LoadingScreenRenderer.java
index 01fa9f477..cf5ee91e3 100644
--- a/game/client/src/main/java/net/minecraft/client/render/LoadingScreenRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/LoadingScreenRenderer.java
@@ -55,14 +55,8 @@ public class LoadingScreenRenderer
         String[] split = tip.split(" ");
         for (String s : split) {
             if (s.startsWith("%")) {
-                KeyBinding binding = null;
                 String sub = s.substring(1);
-                for (KeyBinding b : GameSettings.keys) {
-                    if (b.getId().equals(sub)) {
-                        binding = b;
-                        break;
-                    }
-                }
+                KeyBinding binding = GameSettings.getKeyBinding(sub);
                 if (binding != null) {
                     return tip.replace(s, TextFormatting.BOLD + binding.getKeyName() + TextFormatting.RESET);
                 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/OpenGLHelper.java b/game/client/src/main/java/net/minecraft/client/render/OpenGLHelper.java
index fedbe58df..131e4ddf2 100644
--- a/game/client/src/main/java/net/minecraft/client/render/OpenGLHelper.java
+++ b/game/client/src/main/java/net/minecraft/client/render/OpenGLHelper.java
@@ -1,37 +1,46 @@
 package net.minecraft.client.render;
 
-import java.util.HashSet;
-import java.util.Set;
-
 import com.mojang.logging.LogUtils;
+import net.minecraft.client.Minecraft;
 import net.minecraft.core.Global;
 import net.minecraft.core.enums.EnumOS;
 import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.ARBFramebufferObject;
-import org.lwjgl.opengl.ContextCapabilities;
 import org.lwjgl.opengl.GL41;
 import org.lwjgl.opengl.GLCapabilities;
-import org.lwjgl.opengl.GLContext;
-
-import net.minecraft.client.Minecraft;
 import org.slf4j.Logger;
 
+import java.util.HashSet;
+import java.util.Objects;
+import java.util.Set;
+
 public class OpenGLHelper {
     private static final Logger LOGGER = LogUtils.getLogger();
     private static final Set<String> errors = new HashSet<>();
 
     public static int[] versionPairs = new int[] {4, 6, 4, 3, 4, 1};
 
+    public static boolean contextCreated = false;
     public static boolean gl46 = false;
     public static boolean gl43 = false;
 
+    public static @NotNull String version = "Unknown";
+    public static @NotNull String vendor = "Unknown";
+    public static @NotNull String renderer = "Unknown";
+
     public static void testCapabilities(@NotNull GLCapabilities capabilities) {
+        contextCreated = true;
         LOGGER.info("");
         LOGGER.info("=== GPU VENDOR INFO ===");
         LOGGER.info("OpenGL {}.{}", GL41.glGetInteger(GL41.GL_MAJOR_VERSION), GL41.glGetInteger(GL41.GL_MINOR_VERSION));
-        LOGGER.info(GL41.glGetString(GL41.GL_VERSION));
-        LOGGER.info(GL41.glGetString(GL41.GL_VENDOR));
-        LOGGER.info(GL41.glGetString(GL41.GL_RENDERER));
+
+        version = Objects.requireNonNullElse(GL41.glGetString(GL41.GL_VERSION), "Query Failure");
+        vendor = Objects.requireNonNullElse(GL41.glGetString(GL41.GL_VENDOR), "Query Failure");
+        renderer = Objects.requireNonNullElse(GL41.glGetString(GL41.GL_RENDERER), "Query Failure");
+
+        LOGGER.info(version);
+        LOGGER.info(vendor);
+        LOGGER.info(renderer);
 
         LOGGER.info("");
 
@@ -52,19 +61,21 @@ public class OpenGLHelper {
     }
 
     public static void checkError(String info) {
-        int errorCode = GL41.glGetError();
+        if (Global.DEBUG_MODE) {
+            int errorCode = GL41.glGetError();
 
-        if (errorCode != GL41.GL_NO_ERROR) {
-            if (Global.BUILD_CHANNEL.isUnstableBuild()) {
-                String error = errorCode + " (" + getErrorDescription(errorCode) + "): " + info;
-                throw new RuntimeException("OpenGL Error " + error);
-            }
+            if (errorCode != GL41.GL_NO_ERROR) {
+                if (Global.BUILD_CHANNEL.isUnstableBuild()) {
+                    String error = errorCode + " (" + getErrorDescription(errorCode) + "): " + info;
+                    throw new RuntimeException("OpenGL Error " + error);
+                }
 
-            if (!errors.contains(info)) {
-                errors.add(info);
-                String error = errorCode + " (" + getErrorDescription(errorCode) + "): " + info;
-                LOGGER.error("########## GL ERROR ##########");
-                LOGGER.error("OpenGL Error {}", error);
+                if (!errors.contains(info)) {
+                    errors.add(info);
+                    String error = errorCode + " (" + getErrorDescription(errorCode) + "): " + info;
+                    LOGGER.error("########## GL ERROR ##########");
+                    LOGGER.error("OpenGL Error {}", error);
+                }
             }
         }
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/ParticleEngine.java b/game/client/src/main/java/net/minecraft/client/render/ParticleEngine.java
index 0254e9be9..6f3fa2e70 100644
--- a/game/client/src/main/java/net/minecraft/client/render/ParticleEngine.java
+++ b/game/client/src/main/java/net/minecraft/client/render/ParticleEngine.java
@@ -1,28 +1,31 @@
 package net.minecraft.client.render;
 
-import java.util.*;
-
 import it.unimi.dsi.fastutil.objects.ObjectArrayList;
+import net.minecraft.client.option.GameSettings;
+import net.minecraft.client.option.enums.ParticlesQuality;
 import net.minecraft.client.render.camera.ICamera;
-import net.minecraft.client.render.particle.ParticleBlockBreaking;
 import net.minecraft.client.render.particle.Particle;
+import net.minecraft.client.render.particle.ParticleBlockBreaking;
 import net.minecraft.client.render.renderer.BlendFactor;
 import net.minecraft.client.render.renderer.CompareFunc;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.Shaders;
 import net.minecraft.client.render.renderer.State;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.tessellator.TessellatorParticle;
 import net.minecraft.client.render.tessellator.TessellatorParticleShader;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.TessellatorGeneral;
-import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.world.World;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.joml.primitives.AABBdc;
 
+import java.util.List;
+import java.util.Random;
+
 /**
  * Handles rendering and ticking of client-side particles.
  */
@@ -54,7 +57,7 @@ public final class ParticleEngine {
      */
     public void add(Particle p) {
         int t = p.getParticleTexture();
-        if (this.particles[t].size() >= 4000) {
+        if (this.particles[t].size() >= GameSettings.PARTICLES_CAP.value) {
             this.particles[t].remove(0);
         }
         this.particles[t].add(p);
@@ -152,27 +155,26 @@ public final class ParticleEngine {
     /**
      * Produces a burst of terrain particles at the location a block is destroyed.
      *
-     * @param x    The X coordinate of the destroyed block.
-     * @param y    The Y coordinate of the destroyed block.
-     * @param z    The Z coordinate of the destroyed block.
+     * @param blockPos The coordinate of the destroyed block.
      * @param id   The ID of the destroyed block.
      * @param data The metadata value of the destroyed block.
      */
-    public void destroy(int x, int y, int z, int id, int data) {
+    public void destroy(@NotNull TilePosc blockPos, int id, int data) {
+        if (GameSettings.PARTICLES_QUALITY.value == ParticlesQuality.NONE) return;
         Block<?> block = Blocks.blocksList[id];
         if (block == null) return;
-        int amount = 4;
+        int amount = GameSettings.PARTICLES_QUALITY.value == ParticlesQuality.REDUCED ? 2 : 4;
         if (block == Blocks.FIRE) {
             return;
         }
         for (int xx = 0; xx < amount; xx++) {
             for (int yy = 0; yy < amount; yy++) {
                 for (int zz = 0; zz < amount; zz++) {
-                    double xp = x + (xx + 0.5D) / amount;
-                    double yp = y + (yy + 0.5D) / amount;
-                    double zp = z + (zz + 0.5D) / amount;
+                    double xp = blockPos.x() + (xx + 0.5D) / amount;
+                    double yp = blockPos.y() + (yy + 0.5D) / amount;
+                    double zp = blockPos.z() + (zz + 0.5D) / amount;
                     Side side = Side.getSideById(this.rand.nextInt(6));
-                    add((new ParticleBlockBreaking(this.world, xp, yp, zp, xp - x - 0.5D, yp - y - 0.5D, zp - z - 0.5D, block, side, data)).init(new TilePos(x, y, z)));
+                    add((new ParticleBlockBreaking(this.world, xp, yp, zp, xp - blockPos.x() - 0.5D, yp - blockPos.y() - 0.5D, zp - blockPos.z() - 0.5D, block, side, data)).init(blockPos));
                 }
             }
         }
@@ -181,36 +183,34 @@ public final class ParticleEngine {
     /**
      * Produces falling terrain particles along the side of a block.
      *
-     * @param x    The X coordinate of the block.
-     * @param y    The Y coordinate of the block.
-     * @param z    The Z coordinate of the block.
+     * @param blockPos The coordinate of the block.
      * @param side The side along which to produce particles.
      */
-    public void crack(int x, int y, int z, Side side) {
-        int id = this.world.getBlockId(x, y, z);
-        if (id == 0) {
+    public void crack(@NotNull TilePosc blockPos, @NotNull Side side) {
+        if (GameSettings.PARTICLES_QUALITY.value == ParticlesQuality.NONE) return;
+        Block<?> block = this.world.getBlockType(blockPos);
+        if (block == Blocks.AIR) {
             return;
         }
-        Block<?> block = Blocks.blocksList[id];
         AABBdc bounds = block.getBounds();
         float r = 0.1F;
-        double xp = x + this.rand.nextDouble() * (bounds.maxX() - bounds.minX() - (r * 2.0F)) + r + bounds.minX();
-        double yp = y + this.rand.nextDouble() * (bounds.maxY() - bounds.minY() - (r * 2.0F)) + r + bounds.minY();
-        double zp = z + this.rand.nextDouble() * (bounds.maxZ() - bounds.minZ() - (r * 2.0F)) + r + bounds.minZ();
+        double xp = blockPos.x() + this.rand.nextDouble() * (bounds.maxX() - bounds.minX() - (r * 2.0F)) + r + bounds.minX();
+        double yp = blockPos.y() + this.rand.nextDouble() * (bounds.maxY() - bounds.minY() - (r * 2.0F)) + r + bounds.minY();
+        double zp = blockPos.z() + this.rand.nextDouble() * (bounds.maxZ() - bounds.minZ() - (r * 2.0F)) + r + bounds.minZ();
         if (side == Side.BOTTOM) {
-            yp = (y + bounds.minY()) - r;
+            yp = (blockPos.y() + bounds.minY()) - r;
         } else if (side == Side.TOP) {
-            yp = (y + bounds.maxY()) + r;
+            yp = (blockPos.y() + bounds.maxY()) + r;
         } else if (side == Side.NORTH) {
-            zp = (z + bounds.minZ()) - r;
+            zp = (blockPos.z() + bounds.minZ()) - r;
         } else if (side == Side.SOUTH) {
-            zp = (z + bounds.maxZ()) + r;
+            zp = (blockPos.z() + bounds.maxZ()) + r;
         } else if (side == Side.WEST) {
-            xp = (x + bounds.minX()) - r;
+            xp = (blockPos.x() + bounds.minX()) - r;
         } else if (side == Side.EAST) {
-            xp = x + bounds.maxX() + r;
+            xp = blockPos.x() + bounds.maxX() + r;
         }
-        add((new ParticleBlockBreaking(this.world, xp, yp, zp, 0.0D, 0.0D, 0.0D, block, side, this.world.getBlockMetadata(x, y, z))).init(new TilePos(x, y, z)).setPower(0.2F).setScale(0.6F));
+        add((new ParticleBlockBreaking(this.world, xp, yp, zp, 0.0D, 0.0D, 0.0D, block, side, this.world.getBlockData(blockPos))).init(blockPos).setPower(0.2F).setScale(0.6F));
     }
 
     public int countParticles() {
diff --git a/game/client/src/main/java/net/minecraft/client/render/PostProcessingManager.java b/game/client/src/main/java/net/minecraft/client/render/PostProcessingManager.java
index dbf608462..5ba74f788 100644
--- a/game/client/src/main/java/net/minecraft/client/render/PostProcessingManager.java
+++ b/game/client/src/main/java/net/minecraft/client/render/PostProcessingManager.java
@@ -1,8 +1,10 @@
 package net.minecraft.client.render;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.type.WorldTypes;
 import net.minecraft.core.world.season.Seasons;
 import net.minecraft.core.world.weather.Weather;
@@ -67,7 +69,7 @@ public class PostProcessingManager {
         if (this.mc.currentWorld == null || this.mc.thePlayer == null) return;
 
         this.reset();
-        if (this.mc.gameSettings.colorCorrection.value == 0) return;
+        if (GameSettings.COLOR_CORRECTION.value == 0) return;
 
         final float y = (float) this.mc.thePlayer.y;
         final int maxY = this.mc.currentWorld.getWorldType().getMaxY();
@@ -81,11 +83,11 @@ public class PostProcessingManager {
         float surfaceness = adjustedY / hToQRange;
         surfaceness = MathHelper.clamp(surfaceness, 0.0f, 1.0f);
 
-        double t = this.mc.currentWorld.getBlockTemperature((int) this.mc.thePlayer.x, (int) this.mc.thePlayer.z); // Ranges from 0.0 to 1.0
+        double t = this.mc.currentWorld.getBlockTemperature(new TilePos(this.mc.thePlayer)); // Ranges from 0.0 to 1.0
         if (t == Double.NEGATIVE_INFINITY) t = this.lastTemperature;
         final double temperature = t;
         this.lastTemperature = temperature;
-        double h = this.mc.currentWorld.getBlockHumidity((int) this.mc.thePlayer.x, (int) this.mc.thePlayer.z); // Ranges from 0.0 to 1.0
+        double h = this.mc.currentWorld.getBlockHumidity(new TilePos(this.mc.thePlayer)); // Ranges from 0.0 to 1.0
         if (h == Double.NEGATIVE_INFINITY) h = this.lastHumidity;
         final double humidity = h;
         this.lastHumidity = humidity;
@@ -144,7 +146,7 @@ public class PostProcessingManager {
                 this.current.bMod += 0.1f * intensity * surfaceness;
                 this.current.saturation += -0.2f * intensity * surfaceness;
                 this.current.brightness += -0.1f * intensity * surfaceness;
-            } else if (activeWeather == Weathers.OVERWORLD_FOG && this.mc.gameSettings.fog.value) {
+            } else if (activeWeather == Weathers.OVERWORLD_FOG && GameSettings.FOG.value) {
                 this.current.saturation += -0.4f * intensity * surfaceness;
                 this.current.contrast += -0.25f * intensity * surfaceness;
             }
@@ -177,14 +179,14 @@ public class PostProcessingManager {
         }
 
         // Scaling
-        if (this.mc.gameSettings.colorCorrection.value != 0) {
-            this.current.brightness *= this.mc.gameSettings.colorCorrection.value;
-            this.current.contrast *= this.mc.gameSettings.colorCorrection.value;
-            this.current.exposure *= this.mc.gameSettings.colorCorrection.value;
-            this.current.saturation *= this.mc.gameSettings.colorCorrection.value;
-            this.current.rMod = 1.0f - (1.0f - this.current.rMod) * this.mc.gameSettings.colorCorrection.value;
-            this.current.gMod = 1.0f - (1.0f - this.current.gMod) * this.mc.gameSettings.colorCorrection.value;
-            this.current.bMod = 1.0f - (1.0f - this.current.bMod) * this.mc.gameSettings.colorCorrection.value;
+        if (GameSettings.COLOR_CORRECTION.value != 0) {
+            this.current.brightness *= GameSettings.COLOR_CORRECTION.value;
+            this.current.contrast *= GameSettings.COLOR_CORRECTION.value;
+            this.current.exposure *= GameSettings.COLOR_CORRECTION.value;
+            this.current.saturation *= GameSettings.COLOR_CORRECTION.value;
+            this.current.rMod = 1.0f - (1.0f - this.current.rMod) * GameSettings.COLOR_CORRECTION.value;
+            this.current.gMod = 1.0f - (1.0f - this.current.gMod) * GameSettings.COLOR_CORRECTION.value;
+            this.current.bMod = 1.0f - (1.0f - this.current.bMod) * GameSettings.COLOR_CORRECTION.value;
         }
 
         this.current.brightness = smoothLerp(this.oldCurrent.brightness, this.current.brightness);
